From cedd85595ed417f109c08426ccf387f91d41129e Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Feb 12 2021 06:29:07 +0000
Subject: [PATCH 2106/2232] Pass and parse $crate in type_id impl


---

diff --git a/macro/src/lib.rs b/macro/src/lib.rs
index fc7828b..b39de52 100644
--- a/macro/src/lib.rs
+++ b/macro/src/lib.rs
@@ -37,6 +37,7 @@ use crate::syntax::file::Module;
 use crate::syntax::namespace::Namespace;
 use crate::syntax::qualified::QualifiedName;
 use proc_macro::TokenStream;
+use proc_macro2::TokenTree;
 use syn::parse::{Parse, ParseStream, Parser, Result};
 use syn::parse_macro_input;
 
@@ -75,14 +76,19 @@ pub fn bridge(args: TokenStream, input: TokenStream) -> TokenStream {
 
 #[proc_macro]
 pub fn type_id(input: TokenStream) -> TokenStream {
-    struct TypeId(QualifiedName);
+    struct TypeId {
+        krate: TokenTree,
+        path: QualifiedName,
+    }
 
     impl Parse for TypeId {
         fn parse(input: ParseStream) -> Result<Self> {
-            QualifiedName::parse_quoted_or_unquoted(input).map(TypeId)
+            let krate: TokenTree = input.parse()?;
+            let path = QualifiedName::parse_quoted_or_unquoted(input)?;
+            Ok(TypeId { krate, path })
         }
     }
 
     let arg = parse_macro_input!(input as TypeId);
-    type_id::expand(arg.0).into()
+    type_id::expand(arg.path).into()
 }
diff --git a/src/type_id.rs b/src/type_id.rs
index 6d91e44..bd2b4ea 100644
--- a/src/type_id.rs
+++ b/src/type_id.rs
@@ -4,6 +4,6 @@
 #[macro_export]
 macro_rules! type_id {
     ($($path:tt)*) => {
-        $crate::private::type_id! { $($path)* }
+        $crate::private::type_id! { $crate $($path)* }
     };
 }

